Bug 1857767 - Review Request: python-ephem - Compute positions of the planets and stars
Summary: Review Request: python-ephem - Compute positions of the planets and stars
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1855434 1857281 1871595
TreeView+ depends on / blocked
 
Reported: 2020-07-16 14:21 UTC by Fabian Affolter
Modified: 2020-09-25 16:59 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-09-25 16:59:34 UTC
Type: ---
mhroncok: fedora-review+


Attachments (Terms of Use)

Description Fabian Affolter 2020-07-16 14:21:48 UTC
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/python-ephem.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/python-ephem-3.7.7.1-1.fc31.src.rpm

Project URL: http://rhodesmill.org/pyephem/

Description:
PyEphem provides an ephem Python package for performing high-precision
astronomy computations. The underlying numeric routines are coded in C
and are the same ones that drive the popular XEphem astronomy application.

Koji scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=47304455

rpmlint output:
$ rpmlint python-ephem-3.7.7.1-1.fc31.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint python3-ephem*
2 packages and 0 specfiles checked; 0 errors, 0 warnings.

Fedora Account System Username: fab

This is the successor of python-pyephem which was retired.

Comment 1 Miro Hrončok 2020-07-16 14:45:58 UTC
Spec sanity:

    %{?python_provide:%python_provide python3-%{pypi_name}}


This can be dropped if you target rawhide only (which you probably should because Fedora 31 and 32 have python3-pyephem and his package would conflict).


Consider adding obsoletes/provides for python3-pyephem.


    PYTHONPATH=%{buildroot}%{python3_sitelib} pytest-%{python3_version} -v tests

This can be replaced with simpler:

    %pytest -v tests


    -k "not test_jpl.py"

Please add a comment about why is this deselected. Consider using --ignore on the file directly.


    %ifnarch armv7hl i686

Why are all the tests skipped on 32bit? Plese add a comment that explains it and execute at least some tests if possible.


    %{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

Consider adding trailing slash to ensure this is a directory.

Comment 2 Miro Hrončok 2020-07-16 14:46:35 UTC
s/his package/this package/

Comment 3 Fabian Affolter 2020-09-01 13:26:06 UTC
%changelog
* Tue Sep 01 2020 Fabian Affolter <mail@fabian-affolter.ch> - 3.7.7.1-2
- Update spec file (rhbz#1857767)

Updated files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/python-ephem.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/python-ephem-3.7.7.1-2.fc32.src.rpm

Comment 4 Miro Hrončok 2020-09-02 11:14:47 UTC
(In reply to Miro Hrončok from comment #1)
> Spec sanity:
> 
>     %{?python_provide:%python_provide python3-%{pypi_name}}
> 
> 
> This can be dropped if you target rawhide only (which you probably should
> because Fedora 31 and 32 have python3-pyephem and his package would
> conflict).

Removed.


> Consider adding obsoletes/provides for python3-pyephem.

Added. But the obsolete uses <=, please switch to <. <= is a tad confusing wrt release (and works the same in this case).


>     PYTHONPATH=%{buildroot}%{python3_sitelib} pytest-%{python3_version} -v
> tests
> 
> This can be replaced with simpler:
> 
>     %pytest -v tests

Used.


>     -k "not test_jpl.py"
> 
> Please add a comment about why is this deselected. Consider using --ignore
> on the file directly.

Not added.


>     %ifnarch armv7hl i686
> 
> Why are all the tests skipped on 32bit? Plese add a comment that explains it
> and execute at least some tests if possible.

The entire ifnarch is gone, thanks.


>     %{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info
> 
> Consider adding trailing slash to ensure this is a directory.

Not added.



When you response to my feedback with a new spec file, could you please actually say what was changed? Otherwise I need to backtrack your changes. Thank you.

Comment 5 Miro Hrončok 2020-09-02 12:24:49 UTC


Checking: python3-ephem-3.7.7.1-2.fc34.x86_64.rpm
          python-ephem-doc-3.7.7.1-2.fc34.x86_64.rpm
          python-ephem-debugsource-3.7.7.1-2.fc34.x86_64.rpm
          python-ephem-3.7.7.1-2.fc34.src.rpm
python3-ephem.x86_64: W: hidden-file-or-dir /usr/lib64/python3.9/site-packages/ephem/.pytest_cache
python3-ephem.x86_64: W: hidden-file-or-dir /usr/lib64/python3.9/site-packages/ephem/.pytest_cache
python3-ephem.x86_64: E: version-control-internal-file /usr/lib64/python3.9/site-packages/ephem/.pytest_cache/.gitignore
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_angles.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_bodies.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_cities.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_constants.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_dates.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_jpl.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_launchpad_236872.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_launchpad_244811.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_locales.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_observers.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_rst.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_stars.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_usno.py 644 /usr/bin/env python
python3-ephem.x86_64: E: non-executable-script /usr/lib64/python3.9/site-packages/ephem/tests/test_usno_equinoxes.py 644 /usr/bin/env python
4 packages and 0 specfiles checked; 15 errors, 2 warnings.



Before looking into the shebangs, consider not shipping /usr/lib64/python3.9/site-packages/ephem/tests at all or packaging itto a subpackage.

Comment 6 Fabian Affolter 2020-09-14 21:08:00 UTC
(In reply to Miro Hrončok from comment #4)
> (In reply to Miro Hrončok from comment #1)
> > Consider adding obsoletes/provides for python3-pyephem.
> 
> Added. But the obsolete uses <=, please switch to <. <= is a tad confusing
> wrt release (and works the same in this case).

Changed

> >     -k "not test_jpl.py"
> > 
> > Please add a comment about why is this deselected. Consider using --ignore
> > on the file directly.
> 
> Not added.

Because this test is failing. 

> >     %{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info
> > 
> > Consider adding trailing slash to ensure this is a directory.
> 
> Not added.

It's a file.

> When you response to my feedback with a new spec file, could you please
> actually say what was changed? Otherwise I need to backtrack your changes.
> Thank you.

Sure, sorry.

%changelog
* Mon Sep 14 2020 Fabian Affolter <mail@fabian-affolter.ch> - 3.7.7.1-3
- Ignore JPLTest and remove left-overs from tests 
- Don't ship tests

Updated files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/python-ephem.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/python-ephem-3.7.7.1-3.fc32.src.rpm

Comment 7 Miro Hrončok 2020-09-14 22:20:14 UTC
> It's a file.

Indeed. In that case, the setuptools BuildRequires is superfluous.


> Because this test is failing.

I figured that much ;) Is there an upstream report about this? (To be clear: This is not a blocker for the review.)



Thanks for the update, running fedora-review again.


I've noticed the following files are packaged in python3-ephem:

/usr/lib64/python3.9/site-packages/ephem/doc
/usr/lib64/python3.9/site-packages/ephem/doc/CHANGELOG.rst
/usr/lib64/python3.9/site-packages/ephem/doc/angle.rst
/usr/lib64/python3.9/site-packages/ephem/doc/catalogs.rst
/usr/lib64/python3.9/site-packages/ephem/doc/coordinates.rst
/usr/lib64/python3.9/site-packages/ephem/doc/date.rst
/usr/lib64/python3.9/site-packages/ephem/doc/examples.rst
/usr/lib64/python3.9/site-packages/ephem/doc/index.rst
/usr/lib64/python3.9/site-packages/ephem/doc/newton.rst
/usr/lib64/python3.9/site-packages/ephem/doc/quick.rst
/usr/lib64/python3.9/site-packages/ephem/doc/radec.rst
/usr/lib64/python3.9/site-packages/ephem/doc/reference.rst
/usr/lib64/python3.9/site-packages/ephem/doc/rise-set.rst
/usr/lib64/python3.9/site-packages/ephem/doc/tutorial.rst


Are they used at runtime? If not, consider moving them to the doc package or not packaging them at all.

Comment 8 Miro Hrončok 2020-09-14 22:26:39 UTC
Suggestions:

1) Try making the doc package noarch and see if a Koji build still succeeds.

2) Drop the unused BR on setuptools.

3) Move or remove site-packages/ephem/doc.

4) Add an upstream issue link to a comment for the deselected test.




I leave that up to you. Consider the package APPROVED otherwise.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GNU Lesser General Public License (v3)", "Unknown or
     generated".
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 1054720 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-ephem-3.7.7.1-3.fc34.x86_64.rpm
          python-ephem-doc-3.7.7.1-3.fc34.x86_64.rpm
          python-ephem-debugsource-3.7.7.1-3.fc34.x86_64.rpm
          python-ephem-3.7.7.1-3.fc34.src.rpm
4 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
3 packages and 0 specfiles checked; 0 errors, 0 warnings.



Unversioned so-files
--------------------
python3-ephem: /usr/lib64/python3.9/site-packages/ephem/_libastro.cpython-39-x86_64-linux-gnu.so

Source checksums
----------------
https://files.pythonhosted.org/packages/source/e/ephem/ephem-3.7.7.1.tar.gz :
  CHECKSUM(SHA256) this package     : 36b51a8dc7cfdeb456dd6b8ab811accab8341b2d562ee3c6f4c86f6d3dbb984e
  CHECKSUM(SHA256) upstream package : 36b51a8dc7cfdeb456dd6b8ab811accab8341b2d562ee3c6f4c86f6d3dbb984e


Requires
--------
python3-ephem (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    python(abi)
    rtld(GNU_HASH)

python-ephem-doc (rpmlib, GLIBC filtered):

python-ephem-debugsource (rpmlib, GLIBC filtered):



Provides
--------
python3-ephem:
    python-ephem
    python3-ephem
    python3-ephem(x86-64)
    python3-pyephem
    python3.9-ephem
    python3.9dist(ephem)
    python3dist(ephem)

python-ephem-doc:
    python-ephem-doc
    python-ephem-doc(x86-64)

python-ephem-debugsource:
    python-ephem-debugsource
    python-ephem-debugsource(x86-64)



Generated by fedora-review 0.7.0 (fed5495) last change: 2019-03-17
Command line :try-fedora-review -b 1857767 -m fedora-rawhide-x86_64 --mock-options=--enablerepo=local
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, C/C++, Python
Disabled plugins: R, Haskell, SugarActivity, PHP, Ruby, Java, fonts, Perl, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 9 Gwyn Ciesla 2020-09-16 13:18:24 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-ephem

Comment 10 Fedora Update System 2020-09-16 19:19:44 UTC
FEDORA-2020-98f506e24c has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2020-98f506e24c

Comment 11 Fabian Affolter 2020-09-16 19:24:55 UTC
(In reply to Miro Hrončok from comment #7)
> > It's a file.
> 
> Indeed. In that case, the setuptools BuildRequires is superfluous.

Removed
 
> > Because this test is failing.
> 
> I figured that much ;) Is there an upstream report about this? (To be clear:
> This is not a blocker for the review.)

It's on my todo list. But I need to investigate a little more before complaining.

> I've noticed the following files are packaged in python3-ephem:
> 
> /usr/lib64/python3.9/site-packages/ephem/doc
> /usr/lib64/python3.9/site-packages/ephem/doc/CHANGELOG.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/angle.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/catalogs.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/coordinates.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/date.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/examples.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/index.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/newton.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/quick.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/radec.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/reference.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/rise-set.rst
> /usr/lib64/python3.9/site-packages/ephem/doc/tutorial.rst
> 
> 
> Are they used at runtime? If not, consider moving them to the doc package or
> not packaging them at all.

They are removed as there is a doc subpackage which contain the rendered rst file.

Comment 12 Fedora Update System 2020-09-17 17:55:18 UTC
FEDORA-2020-98f506e24c has been pushed to the Fedora 33 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-98f506e24c \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-98f506e24c

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2020-09-25 16:59:34 UTC
FEDORA-2020-98f506e24c has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.